java异常——捕获异常+再次抛出异常与异常链

【0】README

0.1) 本文描述+源代码均 转自 core java volume 1, 旨在理解 java异常——捕获异常+再次抛出异常与异常链 的相关知识;


【1】捕获异常相关

1.1)如果某个异常发生的时候没有再任何地方进行捕获, 那程序就会运行终止: 并在控制台上打印出异常信息 , 其中包括异常的类型堆栈的内容;
1.2)要想捕获一个异常, 必须设置 try/catch 语句块:

  • 1.2.1)如果在try语句块中抛出了一个在 catch子句中声明的异常类, 那么
    • case1)程序将跳过try 语句块的其余代码;
    • case2)程序将执行 catch 子句中 的处理器代码;
  • 1.2.2)如果在try语句块中没有抛出任何异常, 那么程序将跳过 catch子句;
  • 1.2.3)如果方法中的任何代码抛出了一个在 catch 子句中没有声明的异常类型, 那么这个方法就会立刻退出;

1.3)看个荔枝: (看一个读取文本的程序代码以演示捕获异常的处理过程)

public void read(String filename)
{
    try
    {
        InputStream in = new FileInputStream(filename);  // 创建输入流
        int b;
        while((b=in.read()) != -1)
            process input
    }
    catch(IOException exception)
    {
        exception.printStackTrace(); // 打印栈轨迹;
    }
}

对上述代码的分析(Analysis):

  • A1)需要注意的是, try 语句中的大多数代码都很容易理解, 读取并处理文本行, 直到遇到文件结束符为止;(read 方法可能抛出一个IOException异常)
  • A2)在这种情况下, 将跳出整个while循环, 进入 catch子句, 并生成一个 栈轨迹;

1.4)对于一个普通 的程序来说, 处理以上的对异常处理的方法外,还有其他方法吗?

  • 1.4.1)通常, 最好的选择是: 什么也不做, 而是将异常传递给调用者;如果read方法出现了错误, 那就让read方法的调用者去处理。
  • 1.4.2)如果采用这种方式, 就必须声明这个方法可能抛出一个 IOException(将异常传递给调用者);
public void read(String filename) throws IOException
{
        InputStream in = new FileInputStream(filename);  // 创建输入流
        int b;
        while((b=in.read()) != -1)
            process input
}

Attention)编译器严格地执行 throws 说明符。 如果调用了一个抛出已检查异常的方法, 就必须对它进行处理, 或者将它继续进行传递;
1.5)对于以上两种处理异常的方法, 哪种 方法更好呢?(method1:自己处理(在可能发生异常的函数中添加try/catch 语句块);method2:将异常传递(throw)给调用者,调用者处理)

  • 1.5.1)通常, 应该捕获那些知道如何处理的异常, 而将那些不知道怎么处理的异常继续进行传递;如果想传递一个异常, 就必须在方法的首部添加一个throws 说明符, 以便告知调用者这个方法可能会抛出异常;
  • 1.5.2)阅读API后, 以便知道这个方法可能会抛出哪种异常, 然后再决定是自己处理, 还是添加到 throws 列表中;

Attention)以上规则有个例外: 前面提到, 如果编写一个 覆盖超类的方法, 而这个方法又没有抛出异常, 那么这个方法就必须捕获方法代码中出现的每一个已检查异常。不允许在子类的 throws 说明符中出现超过超类方法所列出的异常类范围;(也就是说父类方法没有抛出异常,你子类方法也不准抛出异常,只能自己添加 try/catch 语句块自己处理)


【2】捕获多个异常

2.1)在一个try 语句块中可以捕获多个异常, 并对不同类型的异常做出不同的处理。可以按照下列方式为每个异常类型使用一个单独的 catch 子句;

try
{}
catch(FileNotFoundException e)
{}
catch(UnknownHostException e)
{}
catch(IOException e)
{}

2.2)要想获得异常对象 的更多信息: 可以试着使用 e.getMessage() 得到详细的错误信息, 或者使用 e.getClass().getName(); 得到异常对象 的实际类型;
2.3)合并catch 子句: 在 java SE7中, 同一个 catch 子句中可以捕获多个异常类型。 例如, 假设对应缺少文件和 未知主机异常的动作是一样的, 就可以合并catch 子句:

try
{}
catch(FileNotFoundException | UnknownHostException e)
{}
catch(IOException e)
{}

Attention)

  • A1)只有当捕获的异常类型彼此间不存在子类关系时 才需要这个特性;
  • A2)捕获多个异常时, 异常变量隐含为 final变量。例如, 不能在以下子句体中为 e 赋不同的 值;
    catch(FileNotFoundException || UnknownHostException e) {}
  • A3)捕获多个异常不仅会让你的代码看起来简单, 还会更高效。生成的字节码只包含一个对应公共catch 子句的代码块;

【3】再次抛出异常与异常链

3.1)在catch子句中可以抛出一个异常, 这样做的目的是 改变异常类型;

  • 3.1.1)看个荔枝:
try
{}
catch(SQLException e)
{
    throw new ServletException("data error : " + e.getMessage());
}

对以上代码的分析(Analysis):

  • A1)这里, ServletException 用带有异常信息文本的构造器来构造;
  • A2)不过, 可以有一种更好的方法, 并且将原始异常设置为新异常的原因:
try
{}
catch(SQLException e)
{
    Throwable se = new ServletException("database error");
    se.initCause(e);
    throw se;
}
  • A3)当捕获到这个异常时, 就可以使用下面的语句重新得到 原始异常:
Throwable e = se.getCause();

Attention)强烈建议使用这种包装技术, 这样可以让用户抛出子系统中的高级异常, 而不会丢失原始异常的小细节; (推荐使用 strongly recommended)

Hint)

  • H1)如果在一个方法中发生了一个已检查异常,而不允许抛出它, 那么包装技术就十分有用。 我们还可以捕获这个已检查异常, 并将它包装成一个 运行时异常;
  • H2)有时候, 你可能只想记录一个异常,再将它重新抛出, 而不做任何改变:
try
{
    access the database
}
catch(Exception e)
{
    logger.log(level, message, e);
    throw e;
}
  • H3)在Java SE7 之前, 将上述代码放入下述方法中, 会出现一个问题;
public void updateRecord() throws SQLException
  • 因为, java 编译器查看catch 块中的 throw 语句, 然后查看e的类型, 会指出这个方法可以抛出任何Exception而不仅仅是 SQLException;
  • H4)java se 7之后(编译器检测语法合法): 编译器会跟踪到 e 来自于try块中, 假设这个 try 块中仅有 的已检查异常 是 SQLException实例, 另外,假设e在catch块中未改变, 将外围方法声明为 throws SQLException 就是合法的;
阅读更多
个人分类: (2)core_java_basic
想对作者说点什么? 我来说一句

没有更多推荐了,返回首页

关闭
关闭
关闭